/******/ (function() { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./src/js/html/html-extension-registry.mjs":
/*!*************************************************!*\
  !*** ./src/js/html/html-extension-registry.mjs ***!
  \*************************************************/
/***/ (function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {

__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _toggle_mjs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./toggle.mjs */ "./src/js/html/toggle.mjs");
/* harmony import */ var _notification_mjs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./notification.mjs */ "./src/js/html/notification.mjs");


class HtmlExtensionRegistry {
  prefix = "wpcb-";
  #availableExtensions = (() => ({
    "toggle": {
      prototype: _toggle_mjs__WEBPACK_IMPORTED_MODULE_0__["default"]
    },
    "notification": {
      prototype: _notification_mjs__WEBPACK_IMPORTED_MODULE_1__["default"]
    }
  }))();
  #list = [];
  constructor() {}
  register(tagName) {
    this.#list.push(tagName);
  }
  init() {
    this.#list.forEach(name => {
      // Check if the element is already defined
      if (customElements.get(this.getTag(name)) !== undefined) {
        return;
      }

      // Check if the element extends another element
      let configuration = this.#availableExtensions[name]?.extends ? {
        extends: this.#availableExtensions[name].extends
      } : {};

      // Register the element
      customElements.define(this.getTag(name), this.#availableExtensions[name].prototype, configuration);
    });
  }
  get list() {
    return this.#list;
  }
  getTag(tagName) {
    return this.prefix + tagName;
  }
}
/* harmony default export */ __webpack_exports__["default"] = (HtmlExtensionRegistry);

/***/ }),

/***/ "./src/js/html/notification.mjs":
/*!**************************************!*\
  !*** ./src/js/html/notification.mjs ***!
  \**************************************/
/***/ (function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {

__webpack_require__.r(__webpack_exports__);
class Notification extends HTMLElement {
  observedAttributes = ["type"];
  #style = null;
  #parts = (() => ({
    text: document.createElement("div")
  }))();
  constructor() {
    super();
    const shadow = this.attachShadow({
      mode: "open"
    });

    // Optionally, you can still use slots for other content
    // shadow.innerHTML = `<slot name="fallback"></slot>`;
    this.#parts.text.textContent = '';
    this.shadowRoot.appendChild(this.#parts.text);
  }
  connectedCallback() {
    this.#setStyle();
    const contentDiv = this.#parts.text;
    if (this.attributes?.type !== null && this.attributes?.type !== undefined) {
      console.log(this.attributes?.type);
      this.#parts.text.classList.add(this.attributes.type.value);
    } else {
      this.#parts.text.classList.add("info");
    }
    setTimeout(() => {
      contentDiv.innerHTML = '';
      this.childNodes.forEach(node => {
        contentDiv.appendChild(node.cloneNode(true));
      });
    }, 10);
  }
  disconnectedCallback() {
    // console.log("Custom element removed from page.");
  }
  adoptedCallback() {
    // console.log("Custom element moved to new page.");
  }
  attributeChangedCallback(name, oldValue, newValue) {
    // console.log(`Attribute ${name} has changed.`);

    if (name === "type") {
      this.#parts.text.classList.remove(oldValue);
      this.#parts.text.classList.add(newValue);
    }
  }
  #removeTabsAndNewLines(text) {
    return text.replace(/\t/g, "").replace(/\n/g, "");
  }
  #setStyle() {
    this.#style = document.createElement("style");
    this.#style.textContent = `
      div {
      box-sizing: border-box;
          padding: 10px;
          color: white;
        display: block;
        flex-direction: column;
        align-items: center;
        justify-content: center;
        width: 100%;
        height: 100%;
        background-color: inherit;
        line-height: 1.5;
      }
      
      div.error {
        background-color: #f44336;
      }
      
        div.warning {
            background-color: #ffeb3b;
            color: darkslategray;
        }
        
        div.success {
            background-color: #4caf50;
        }
        
        div.info {
            background-color: #2196F3FF;
        }
    `;
    this.shadowRoot.appendChild(this.#style);
  }
  set type(value) {
    this.setAttribute("type", value);
  }
  get type() {
    return this.getAttribute("type");
  }
}
/* harmony default export */ __webpack_exports__["default"] = (Notification);

/***/ }),

/***/ "./src/js/html/toggle.mjs":
/*!********************************!*\
  !*** ./src/js/html/toggle.mjs ***!
  \********************************/
/***/ (function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {

__webpack_require__.r(__webpack_exports__);
class Toggle extends HTMLElement {
  static formAssociated = true;
  observedAttributes = ["text", "checked"];
  #parts = (() => ({
    containerLabel: document.createElement("label"),
    title: document.createElement("span"),
    switchElement: document.createElement("span"),
    input: document.createElement("input"),
    spanSlider: document.createElement("span")
  }))();
  #style = null;
  #target = null;
  constructor() {
    super();
    this.internals_ = this.attachInternals();
    const shadow = this.attachShadow({
      mode: "open"
    });
    const containerLabel = this.#createHTML();
    this.shadowRoot.appendChild(this.#parts.title);
    shadow.appendChild(containerLabel);
    this.#setStyle();
  }
  connectedCallback() {
    const text = this.attributes.text.value;
    this.#parts.title.innerText = text;
    if (this.attributes?.checked?.value === "true" || this.attributes?.checked && this.attributes?.checked?.value !== "false") {
      this.#parts.input.checked = true;
    }
    if (this.attributes?.for !== undefined) {
      document.addEventListener("DOMContentLoaded", () => {
        let target = document.querySelector(`#${this.attributes.for.value}`);
        if (target !== null && target !== undefined) {
          target.disabled = !this.#parts.input.checked;
          this.target = target;
        }
      });
    }
    this.#parts.input.addEventListener("change", () => {
      if (this.hasAttribute("checked")) {
        this.attributes.checked.value = this.#parts.input.checked;
      } else {
        this.setAttribute("checked", this.#parts.input.checked);
      }
      this.internals_.setFormValue(this.#parts.input.checked ? "on" : "off");
      this.dispatchEvent(new Event("change", {
        bubbles: true
      }));
    });
    this.addEventListener("change", () => {
      if (this.target !== null && this.target !== undefined) {
        this.target.disabled = !this.#parts.input.checked;
      }
    });
  }
  disconnectedCallback() {
    // console.log("Custom element removed from page.");
  }
  adoptedCallback() {
    // console.log("Custom element moved to new page.");
  }
  attributeChangedCallback(name, oldValue, newValue) {
    //console.log(`Attribute ${name} has changed.`);

    if (name === 'checked') {
      this.target.disabled = !this.#parts.input.checked;
    }
  }
  #createHTML() {
    this.#parts.switchElement.classList.add("switch");
    this.#parts.input.type = "checkbox";
    this.#parts.spanSlider.classList.add("slider");
    this.#parts.title.style.verticalAlign = "-webkit-baseline-middle";
    this.#parts.switchElement.appendChild(this.#parts.input);
    this.#parts.switchElement.appendChild(this.#parts.spanSlider);
    this.#parts.containerLabel.appendChild(this.#parts.switchElement);
    return this.#parts.containerLabel;
  }
  #setStyle() {
    this.#style = document.createElement("style");
    this.#style.textContent = `
        label {
                position: relative;
              display: inline-block;
              width: 60px;
              height: 34px;
              vertical-align: inherit;
              margin-left: 10px;
        }
        
        input {
            opacity: 0;
            width: 0;
            height: 0;
          }

          .slider {
            position: absolute;
            cursor: pointer;
            top: 0;
            left: 0;
            right: 0;
            bottom: 0;
            background-color: #ccc;
            -webkit-transition: .4s;
            transition: .4s;
            border-radius: 34px;
          }

          .slider:before {
            position: absolute;
            content: "";
            height: 26px;
            width: 26px;
            left: 4px;
            bottom: 4px;
            background-color: white;
            -webkit-transition: .4s;
            transition: .4s;
            border-radius: 50%;
          }
        
          input:checked + .slider {
            background-color: #2196F3FF;
          }
        
          input:focus + .slider {
            box-shadow: 0 0 1px #2196F3FF;
          }
        
      
          input:checked + .slider:before {
            -webkit-transform: translateX(26px);
            -ms-transform: translateX(26px);
            transform: translateX(26px);
          }
        `;
    this.shadowRoot.appendChild(this.#style);
  }
  get value() {
    return this.#parts.input.checked;
  }
  set value(value) {
    this.#parts.input.checked = value;
  }
  get checked() {
    return this.#parts.input.checked;
  }
  set checked(value) {
    this.#parts.input.checked = value;
  }
  set name(value) {
    this.attributes.name = value;
  }
  get name() {
    return this.attributes?.name;
  }
  set for(value) {
    this.attributes.for = value;
  }
  get for() {
    return this.attributes?.for;
  }
}
/* harmony default export */ __webpack_exports__["default"] = (Toggle);

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	!function() {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = function(exports) {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	}();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
!function() {
/*!*******************************!*\
  !*** ./src/html-extension.js ***!
  \*******************************/
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _js_html_html_extension_registry_mjs__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./js/html/html-extension-registry.mjs */ "./src/js/html/html-extension-registry.mjs");

const registry = new _js_html_html_extension_registry_mjs__WEBPACK_IMPORTED_MODULE_0__["default"]();

// Register the HTML extension
registry.register("toggle");
registry.register("notification");
console.log(registry.list);
registry.init();
}();
/******/ })()
;
//# sourceMappingURL=html-extension.js.map