<?php

namespace JimsCustomerBooking\Admin\BackendPages;

use JimsCustomerBooking\Helpers\OptionHelper;
use JimsCustomerBooking\Helpers\SettingsHelper;
use JimsCustomerBooking\Helpers\StringHelper;

if (!class_exists('JimsCustomerBooking\Admin\BackendPages\FormCustomizeSettingsPage')) {
    class FormCustomizeSettingsPage extends BackendPage
    {
        use SettingsTrait;

        public static string $option_name = '';

        protected string $name = 'Form Customizer';
        protected string $menu_title = 'Form Customizer';
        protected string $parent_slug = 'wpcb_form_customize_settings.php';
        protected string $menu_slug = 'wpcb_form_customize_settings.php';
        protected string $template_name = 'settings.customize';
        protected bool $hide_menu_item = true;

        public function getContent(): void
        {
            $options = OptionHelper::get(static::$option_name, []);

            $this->getTemplate()->render([
                'title' => $this->name,
                'options' => $options,
                'pages' => SettingsHelper::getSettingsPages(),
                'css_class' => StringHelper::getPrefixed('wrapper'),
                'parts' => $this->getParts(),
                'assets_url' => JIMS_CBP_URL . 'build',
            ], true, '</div></div></div>');
        }
    }
}
